import os
import sys
import copy
import pickle
from nasbench import api
from tqdm import tqdm
from collections import namedtuple


def dump_nas_bench_full_to_pkl_file(metrics_cache_file):
    """
    Loading nas bench data, save them in a list and dump it using pickle
    :param metrics_cache_file: pickle filename
    """
    nasbench = api.NASBench('nasbench_full.tfrecord')
    print('\nIterating over unique models in the dataset.')
    cache_list = []
    for unique_hash in tqdm(nasbench.hash_iterator(), desc="Reading architecture metrics", ascii=True):
        fixed_metrics, computed_metrics = nasbench.get_metrics_from_hash(unique_hash)
        assert len(set(fixed_metrics.keys()).intersection(set(computed_metrics.keys()))) == 0
        complete_dict = copy.deepcopy(fixed_metrics)
        complete_dict.update(computed_metrics)
        cache_list.append(complete_dict)
    print("Caching {} dicts to nas_bench_metrics_file: {}".format(len(cache_list), metrics_cache_file))
    with open(metrics_cache_file, "wb") as f:
        pickle.dump(cache_list, f, protocol=4)


if __name__ == "__main__":
    # dump_nas_bench_full_to_pkl_file("../cache/nas_bench_data_list.pkl")
    nb301 = NB301()
    nb301.run_example()
    print("done")
