# PPO_GAN + ProxylessNAS code

## Commands:

- To evaluate a ProxylessNAS space architecture with its labels:
    ```
    python -m proxyless_nas.search.load_labels_save_net --path proxyless_nas/evaluations/arch0 --arch_labels="['input', '3x3_MBConv6', '3x3_MBConv3', '7x7_MBConv6', '3x3_MBConv3', '5x5_MBConv3', '5x5_MBConv3', '3x3_MBConv6', '5x5_MBConv6', '5x5_MBConv3', '3x3_MBConv6', '3x3_MBConv3', '7x7_MBConv6', '7x7_MBConv3', '5x5_MBConv6', '5x5_MBConv6', '3x3_MBConv3', '5x5_MBConv6', '5x5_MBConv6', '3x3_MBConv3', '7x7_MBConv6', '7x7_MBConv6', 'output']"
    python -m proxyless_nas.search.imagenet_run_exp --path ./proxyless_nas/evaluations/arch0 --train
    ```

- To warmup the PN supernet and save the warmup checkpoint:
    ```
    python -m proxyless_nas.search.imagenet_arch_search --path proxyless_nas --gpu='0,1,2,3,4,5,6,7' --n_epochs 1 --warmup_epochs 160
    ```

- To random generate 1000 architectures, and evaluate on frozen supernet:
    ```
    python ppo_gan_pn_evaluate_arch.py
    ```

- To run search with PPOGAN + ProxylessNAS forzen supernet warmed-up ckpt:
    ```
    python ppo_gan_pn_search_frozen.py -model_name ppogan_pn_iter_10 --path logs/runs/ppogan_pn_iter_10/ -ppo_num_iterations 10 -ppo_random_init_set_size 100 -ppo_num_desired_blocks_eval 100 -ppo_num_desired_blocks_inc 100 -path_to_block2acc checkpoint/init_100_block2acc_dict_warmup_160.pkl
    ```
