# general string constants
OP_DELIM = "->"
PAD_TOKEN = "<PAD>"
OOV_TOKEN = "<OOV>"

# nas_bench_101 related string constants
N_TRAIN_PARAMS_NAS_BENCH = "trainable_parameters"
ARCH_OP_LIST_NAS_BENCH = "module_operations"
ARCH_ADJ_MATRIX_NAS_BENCH = "module_adjacency"
ARCH_OP_CONV33_NAS_BENCH = "conv3x3-bn-relu"
ARCH_OP_CONV11_NAS_BENCH = "conv1x1-bn-relu"
ARCH_OP_MP33_NAS_BENCH = "maxpool3x3"
ARCH_OP_INPUT_NAS_BENCH = "input"
ARCH_OP_OUTPUT_NAS_BENCH = "output"
ARCH_PATH_STR_LIST_NAS_BENCH = "path_string_list"
ARCH_PATH_ENCODING_LIST_NAS_BENCH = "path_encoding_list"
ARCH_TOPO_ENCODING_LISTS_NAS_BENCH = "topological_op_encoding_lists" # topological sorted operators as a list of one hot vectors
ARCH_LVL_OP_ENCODING_LIST_NAS_BENCH = "level_op_encoding_list" # used when representing an arch using 1 feature vector
ARCH_FULL_LVL_OP_ENCODING_LISTS_NAS_BENCH = "full_level_op_encoding_lists" # includes input/output op and is a list of lists
ARCH_OP_ENCODING_LIST_NAS_BENCH = "op_encoding_list" # used when representing an operation using 1 feature vector
ARCH_STD_N_PARAMS_NAS_BENCH = "standardized_n_trainable_params"
ARCH_NORM_N_PARAMS_NAS_BENCH = "norm_n_trainable_params"
ARCH_EDGE_LIST_NAS_BENCH = "edge_list"
ARCH_FEATURE_LIST_NAS_BENCH = "complete_feature_list"
ARCH_FAISS_KNN_LIST_NAS_BENCH = "faiss_knn_list"
ARCH_REV_ADJ_LIST_NAS_BENCH = "reverse_adj_list" # each node can only have preceding neighbors indices in its adj list
HALF_TRAIN_TIME_NAS_BENCH = "halfway_training_time"
HALF_TRAIN_ACC_NAS_BENCH = "halfway_train_accuracy"
HALF_VALID_ACC_NAS_BENCH = "halfway_validation_accuracy"
HALF_TEST_ACC_NAS_BENCH = "halfway_test_accuracy"
TRAIN_TIME_NAS_BENCH = "final_training_time"
MEAN_TRAIN_TIME_NAS_BENCH = "avg_final_training_time"
STD_TRAIN_TIME_NAS_BENCH = "std_final_training_time"
STANDARD_TRAIN_TIME_NAS_BENCH = "standardized_final_training_time"
NORM_TRAIN_TIME_NAS_BENCH = "normalized_final_training_time"
TRAIN_ACC_NAS_BENCH = "final_train_accuracy"
VALID_ACC_NAS_BENCH = "final_validation_accuracy"
TEST_ACC_NAS_BENCH = "final_test_accuracy"
EPOCH_4_METRICS_NAS_BENCH = 4
EPOCH_12_METRICS_NAS_BENCH = 12
EPOCH_36_METRICS_NAS_BENCH = 36
EPOCH_108_METRICS_NAS_BENCH = 108
TARGET_INTERVAL = "target_interval"
TARGET_INTERVAL_CLASS = "target_interval_class"
ARCH_BLOCK_ENCODING_LIST = "arch_block_encoding_list"
TEST_ACC_IMAGE_NET = "image_net_test_accuracy"
FAKE_DATA_FEATURE = "fake_data_feature"
FAKE_DATA_TARGET = "fake_data_target"
DATA = "data"
DATA_TYPE = "data_type"
UNIQUE_NODE2FEATURE = "unique_node2feature"
UNIQUE_FEATURE_LIST = "unique_feature_list"
UNIQUE_NODE2INDEX = "unique_node2index"
TARGET_EDGE = "target_edge"
TARGET_FIRST_NODE_IDX = "target_first_node_idx"
TARGET_SECOND_NODE_IDX = "target_second_node_idx"
TARGET_STOP = "target_stop"

# BLOCK: constants related to our block data
BLOCK_ADJ_LIST = "adj_list"
BLOCK_NODE_FEATURE = "node_feature"
BLOCK_EDGE_LIST = "block_edge_list"
BLOCK_OPERATOR_INDICES = "block_operator_indices"
BLOCK_INPUT_TYPE_INDICES = "block_input_type_indices"
BLOCK_ACTIVATION_TYPE_INDICES = "block_activation_type_indices"
BLOCK_OUTPUT_TYPE_INDICES = "block_output_type_indices"
BLOCK_UNIQUE_STR_ID = "block_unique_string_id"

# DK: string constants used to index batch dict produced by custom data loaders, see data_loaders.py
DK_BATCH_SIZE = "batch_size"
DK_TORCH_GEO_BATCH_DATA_LIST = "torch_geo_batch_data_list"
DK_BATCH_TARGET_TSR = "batch_target_tensor"
DK_BATCH_UNIQUE_STR_ID_SET = "batch_unique_id_set"
DK_BATCH_NODE_LABEL_LIST = "batch_node_label_list"
DK_BATCH_NODE_FEATURE_TSR = "batch_node_feature_tsr"
DK_BATCH_NODE_FEATURE_TSR_1 = "batch_node_feature_tsr_1"
DK_BATCH_NODE_FEATURE_TSR_2 = "batch_node_feature_tsr_2"
DK_BATCH_NODE_FEATURE_TSR_LIST = "batch_node_feature_tsr_list"
DK_BATCH_EDGE_TSR_LIST = "batch_edge_tsr_list"
DK_BATCH_EDGE_TSR_LIST_1 = "batch_edge_tsr_list_1"
DK_BATCH_EDGE_TSR_LIST_2 = "batch_edge_tsr_list_2"
DK_BATCH_OUTPUT_INDEX_TSR = "batch_output_index_tsr"
DK_BATCH_IS_TRAIN = "batch_is_for_training"
DK_BATCH_FEATURE_TSR = "batch_feature_tsr"
DK_BATCH_SEQ_MASK_TSR = "batch_sequence_mask_tsr"
DK_BATCH_OP_TARGET_TSR = "batch_op_target_tensor"
DK_BATCH_INPUT_TYPE_TARGET_TSR = "batch_input_type_target_tensor"
DK_BATCH_ACTIVATION_TARGET_TSR = "batch_activation_target_tensor"
DK_BATCH_OUTPUT_TYPE_TARGET_TSR = "batch_output_type_target_tensor"
DK_BATCH_ADJ_TARGET_TSR = "batch_adj_target_tensor"
DK_BATCH_LATENCY_TARGET_TSR = "batch_latency_target_tensor"
DK_BATCH_DECODER_OP_INPUT_TSR = "batch_decoder_op_input_tensor"
DK_BATCH_DECODER_INPUT_TYPE_INPUT_TSR = "batch_decoder_input_type_input_tensor"
DK_BATCH_DECODER_ACTIVATION_INPUT_TSR = "batch_decoder_activ_input_tensor"
DK_BATCH_DECODER_OUTPUT_TYPE_INPUT_TSR = "batch_decoder_output_type_input_tensor"
DK_BATCH_DECODER_ADJ_INPUT_TSR = "batch_decoder_adj_input_tensor"
DK_BATCH_N_UNIQUE_OPS = "batch_num_unique_operators"
DK_BATCH_N_OPS = "batch_num_operators"
DK_BATCH_N_ADJ_EDGES = "batch_num_adjacency_edges"
DK_BATCH_GLOBAL_INDEX_LIST = "batch_global_index_list"
DK_BATCH_RANDOM_EMBEDDING= "batch_random_embedding"
DK_BATCH_TARGET_FIRST_NODE_TSR = "batch_target_first_node_tensor"
DK_BATCH_TARGET_SECOND_NODE_TSR = "batch_target_second_node_tensor"
DK_BATCH_TARGET_EDGE_TYPE_TSR = "batch_target_edge_type_tensor"
DK_BATCH_TARGET_STOP_TSR = "batch_target_stop_tensor"
DK_BATCH_LAST_NODE_IDX_LIST = "batch_last_node_idx_list"
DK_BATCH_LAST_NODE_IDX_LIST_1 = "batch_last_node_idx_list_1"
DK_BATCH_LAST_NODE_IDX_LIST_2 = "batch_last_node_idx_list_2"
DK_BATCH_PARTIAL_GRAPH_IDX_LIST = "batch_partial_graph_idx_list"
DK_BATCH_TARGET_ACC_TSR = "batch_target_acc_tensor"
DK_BATCH_TARGET_LATENCY_TSR = "batch_target_latency_tensor"

# CHKPT: checkpoint dict keys
CHKPT_COMPLETED_EPOCHS = "completed_epochs"
CHKPT_MODEL = "model"
CHKPT_DISCRIMINATOR = "discriminator"
CHKPT_OPTIMIZER = "optimizer"
CHKPT_METADATA = "metadata"
CHKPT_PARAMS = "params"
CHKPT_BEST_EVAL_RESULT = "best_eval_result"
CHKPT_BEST_EVAL_EPOCH = "best_eval_epoch"
CHKPT_PAST_EVAL_RESULTS = "past_eval_results"
CHKPT_ITERATION = "iteration"
CHKPT_BEST_EVAL_ITERATION = "best_eval_iteration"
CHKPT_ACTOR_CRITIC = "actor_critic"
CHKPT_ENV_TRAJECTORY = "env_trajectory"
CHKPT_ENV_STEP_REWARD_MODULE = "env_step_reward_module"
CHKPT_ENV_FINAL_REWARD_MODULE = "env_final_reward_module"
CHKPT_PARETO_FRONT = "pareto_front"
CHKPT_EVALUATOR = "evaluator"
CHKPT_GNN_PERF_PREDICTOR = "gnn_perf_predictor"
CHKPT_ENCODER = "encoder"
CHKPT_DECODER = "decoder"

# Nas-Bench-101
NB101_MAX_NUM_NODES_PER_BLOCK = 7
NB101_NUM_INTERNAL_NODES_PER_BLOCK = NB101_MAX_NUM_NODES_PER_BLOCK - 2
NB101_SUPER_BLOCK_OUTPUT_NODE_IDX = 5
NB101_SEARCHABLE_OPS = ("conv1x1-bn-relu", "conv3x3-bn-relu", "maxpool3x3")
NB101_INPUT_NODE_LABEL = "input"
NB101_OUTPUT_NODE_LABEL = "output"
NB101_OP2IDX = {
    "input": 0,
    "output": 1,
    "conv1x1-bn-relu": 2,
    "conv3x3-bn-relu": 3,
    "maxpool3x3": 4,
}
NB101_IDX2OP = {v:k for k,v in NB101_OP2IDX.items()}
assert len(NB101_OP2IDX) == len(NB101_IDX2OP)
NB101_RES_NET_BLOCKS = [
    (
        ["input", "conv3x3-bn-relu", "conv3x3-bn-relu", "output"],
        [
            [0, 1, 2, 0],
            [1, 2, 3, 3]
        ]
    )
]
NB101_RES_NET_VALID_ACC = 0.9385016163190206
NB101_RES_NET_TEST_ACC = 0.931824266910553
NB101_RES_NET_TRAIN_TIME = 2251.614990234375
NB101_RES_NET_N_PARAMS = 20346506

NB101_INCEPTION_BLOCKS = [
    (
        ["input", "conv1x1-bn-relu", "conv3x3-bn-relu", "conv3x3-bn-relu", "conv3x3-bn-relu", "maxpool3x3", "output"],
        [
            [0, 1, 0, 2, 0, 3, 4, 0, 5],
            [1, 6, 2, 6, 3, 4, 6, 5, 6]
        ]
    )
]
NB101_INCEPTION_VALID_ACC = 0.9363648295402527
NB101_INCEPTION_TEST_ACC = 0.9308560291926066
NB101_INCEPTION_TRAIN_TIME = 1155.9630533854167
NB101_INCEPTION_N_PARAMS = 2694282


# NB201
NB201_MAX_NUM_NODES_PER_BLOCK = 8
NB201_NUM_INTERNAL_NODES_PER_BLOCK = NB101_MAX_NUM_NODES_PER_BLOCK - 2
NB201_INPUT_NODE_LABEL = "input"
NB201_OUTPUT_NODE_LABEL = "output"
NB201_SEARCHABLE_OPS = ("nor_conv_3x3", "nor_conv_1x1", "avg_pool_3x3", "skip_connect", "none")
NB201_SCAFFOLD_LABELS = list(NB201_SEARCHABLE_OPS)
NB201_OP2IDX = {
    NB201_INPUT_NODE_LABEL: 0,
    NB201_OUTPUT_NODE_LABEL: 1,
    'nor_conv_3x3': 2,
    'nor_conv_1x1': 3,
    'avg_pool_3x3': 4,
    'skip_connect': 5,
    'none': 6,
}
NB201_IDX2OP = {v:k for k, v in NB201_OP2IDX.items()}
assert len(NB201_IDX2OP) == len(NB201_OP2IDX)
NB201_MAX_FLOPS_C10 = 220.11969
NB201_MIN_FLOPS_C10 = 7.78305
NB201_AVG_FLOPS_C10 = 54.89653436992438
NB201_MAX_TEST_ACC_C10 = 0.9437333333333333
NB201_MIN_TEST_ACC_C10 = 0.1
NB201_AVG_TEST_ACC_C10 = 0.8705633482666764
NB201_MAX_FLOPS_C100 = 220.12554
NB201_MIN_FLOPS_C100 = 7.7889
NB201_AVG_FLOPS_C100 = 54.90238436991752
NB201_MAX_TEST_ACC_C100 = 0.7351333332112631
NB201_MIN_TEST_ACC_C100 = 0.009999999987284344
NB201_AVG_TEST_ACC_C100 = 0.6138785192321963
NB201_MAX_FLOPS_IMG_NET = 55.037560000000006
NB201_MIN_FLOPS_IMG_NET  = 1.9534
NB201_AVG_FLOPS_IMG_NET  = 13.731771092480367
NB201_MAX_TEST_ACC_IMG_NET  = 0.4731111100599501
NB201_MIN_TEST_ACC_IMG_NET  = 0.008333333310021293
NB201_AVG_TEST_ACC_IMG_NET = 0.33568326711927277
NB201_SUPER_BLOCK_OUTPUT_NODE_IDX = 6


# Single path macro net
SP_INPUT_NODE_LABEL = "input"
SP_OUTPUT_NODE_LABEL = "output"


# EfficientNet-B0 space
EB0_MAX_NUM_NODES_PER_BLOCK = 9
EB0_NUM_INTERNAL_NODES_PER_BLOCK = EB0_MAX_NUM_NODES_PER_BLOCK - 2
EB0_INPUT_NODE_LABEL = "input"
EB0_OUTPUT_NODE_LABEL = "output"
EB0_OP2IDX = {
    EB0_INPUT_NODE_LABEL: 0,
    EB0_OUTPUT_NODE_LABEL: 1,
    "MBConv-e1-k3": 2,
    "MBConv-e1-k5": 3,
    "MBConv-e3-k3": 4,
    "MBConv-e3-k5": 5,
    "MBConv-e6-k3": 6,
    "MBConv-e6-k5": 7,
}
EB0_IDX2OP = {v:k for k, v in EB0_OP2IDX.items()}
assert len(EB0_OP2IDX) == len(EB0_IDX2OP)
EB0_SEARCHABLE_OPS = ("MBConv-e1-k3", "MBConv-e1-k5",
                      "MBConv-e3-k3", "MBConv-e3-k5",
                      "MBConv-e6-k3", "MBConv-e6-k5")

EB0_ORIGINAL_OPS = ["input", "MBConv-e1-k3", "MBConv-e6-k3",
                    "MBConv-e6-k5", "MBConv-e6-k3", "MBConv-e6-k5",
                    "MBConv-e6-k5", "MBConv-e6-k3", "output"]


# ProxylessNAS space
PN_MAX_NUM_NODES_PER_BLOCK = 23
PN_NUM_INTERNAL_NODES_PER_BLOCK = PN_MAX_NUM_NODES_PER_BLOCK - 2
PN_INPUT_NODE_LABEL = "input"
PN_OUTPUT_NODE_LABEL = "output"
PN_OP2IDX = {
    PN_INPUT_NODE_LABEL: 0,
    PN_OUTPUT_NODE_LABEL: 1,
    '3x3_MBConv3': 2,
    '3x3_MBConv6': 3,
    '5x5_MBConv3': 4,
    '5x5_MBConv6': 5,
    '7x7_MBConv3': 6,
    '7x7_MBConv6': 7,
    'Zero': 8
} # Make sure to keep 'Zero' layer at the end of this.
PN_IDX2OP = {v:k for k, v in PN_OP2IDX.items()}
assert len(PN_OP2IDX) == len(PN_IDX2OP)
PN_SEARCHABLE_OPS = ('3x3_MBConv3', '3x3_MBConv6',
                      '5x5_MBConv3', '5x5_MBConv6',
                      '7x7_MBConv3', '7x7_MBConv6',
                      'Zero') # Make sure to keep 'Zero' layer at the end of this.

PN_ORIGINAL_OPS = [ 'input',
                    '5x5_MBConv3', 'Zero', 'Zero', 'Zero', 
                    '7x7_MBConv3', '3x3_MBConv3', 'Zero', 'Zero',
                    '7x7_MBConv6', '5x5_MBConv3', 'Zero', 'Zero',
                    '5x5_MBConv6', '3x3_MBConv3', '5x5_MBConv3', 'Zero',
                    '7x7_MBConv6', '7x7_MBConv6', '7x7_MBConv6', '5x5_MBConv6',
                    '7x7_MBConv6',
                    'output']

PN_OP2IDX_SUPERNET = { # only for ProxylessNAS supernet
    '3x3_MBConv3': 0,
    '3x3_MBConv6': 1,
    '5x5_MBConv3': 2,
    '5x5_MBConv6': 3,
    '7x7_MBConv3': 4,
    '7x7_MBConv6': 5,
    'Zero': 6
}
PN_IDX2OP_SUPERNET = {v:k for k, v in PN_OP2IDX_SUPERNET.items()}